import java.applet.*;
import java.awt.*;
import java.awt.print.*;
import java.awt.event.*;
import java.beans.*;
import java.lang.reflect.*;
import java.net.*;
import java.io.*;
import java.text.*;
import java.util.*;
import javax.help.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.plaf.*;
import javax.swing.plaf.metal.*;

import polysys.cert.*;
import polysys.gui.*;
import polysys.ext.*;
import polysys.ext.client.*;
import polysys.sql.*;
import polysys.util.*;
import polysys.gau.*;
import polysys.coll.*;

import hu.polysys.cryptosigno.api.*;
import hu.polysys.cryptosigno.api.a2.*;

import hu.polysys.cryptosigno.app.common.*;
import hu.polysys.cryptosigno.app.common.config.*;
import hu.polysys.cryptosigno.app.common.gui.*;

import hu.polysys.epa.client.fir.sign.*;


/**
* FIRA indtpult.
*/
public class FIRAStarter
{
/**
* Szveg beviteli mezk szoksos szlessge, karakterben.
*/
  static int TEXT_FIELD_WIDTH = 30;
/**
* Az ablak.
*/
  protected JFrame Frame;
/**
* A <code>TabPanel</code>.
*/
  protected JTabbedPane TabPanel;
/**
* Az opcik panel.
*/
  protected OptionPane OptionPanel;
/**
* A FIRA alkalmazs (panel).
*/
  protected Main FIRA;
/**
* UI megnevezse.
*/
  protected String CurrentUI;
/**
* UI tma megnevezse.
*/
  protected String CurrentUIThemeName;
/**
* Egy <code>FileChooser</code>.
*/
  protected FileChooser FileChooser;
/**
* Statikus inicializls.
*/
static
{
  CustomizeFileChoosers();
}


/**
* Konstruktor.
*/
  public FIRAStarter() throws Exception
  {
    Object o = new polysys.gui.Button();
    javax.swing.UIManager.put("ClassLoader",o.getClass().getClassLoader());
    polysys.gui.plaf.kunststoff.KunststoffLookAndFeel laf0 = new polysys.gui.plaf.kunststoff.KunststoffLookAndFeel();
    javax.swing.plaf.metal.MetalTheme theme0 = new javax.swing.plaf.metal.DefaultMetalTheme();
    laf0.setCurrentGradientTheme(new polysys.gui.plaf.kunststoff.KunststoffGradientTheme());
    laf0.setCurrentTheme(theme0);
    //
    CurrentUI = "Kunststoff";
    CurrentUIThemeName = "SnowLimit";
    if ( UTIL_.UnderWindows() )
    {
      CurrentUI = "Windows";
      CurrentUIThemeName = "";
    }
    else if ( UTIL_.UnderMacOSX() )
    {
      CurrentUI = "Macintosh";
      CurrentUIThemeName = "";
    }
    //
    javax.swing.plaf.metal.MetalTheme CurrentUITheme = null;
    if ( ! UTIL_.Empty(CurrentUIThemeName) )
      CurrentUITheme = polysys.gui.ThemeManager.GetTheme(CurrentUIThemeName);
    // GUI inicializls
    GUI_.BeforeChangeLAF(CurrentUI,CurrentUITheme);
    //
    // Metal
    if ( CurrentUI.equals("Metal") )
    {
      javax.swing.plaf.metal.MetalLookAndFeel.setCurrentTheme(CurrentUITheme);
      javax.swing.UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
      javax.swing.plaf.metal.MetalLookAndFeel.setCurrentTheme(CurrentUITheme);
    }
    // Kunststoff
    else if ( CurrentUI.equals("Kunststoff") )
    {
      polysys.gui.plaf.kunststoff.KunststoffLookAndFeel laf = new polysys.gui.plaf.kunststoff.KunststoffLookAndFeel();
      laf.setCurrentGradientTheme(new polysys.gui.plaf.kunststoff.KunststoffGradientTheme());
      laf.setCurrentTheme(CurrentUITheme);
      javax.swing.UIManager.setLookAndFeel(laf);
    }
    // Windows
    else if ( CurrentUI.equals("Windows") )
    {
      javax.swing.UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
    }
    // Motif
    else if ( CurrentUI.equals("Motif") )
    {
      javax.swing.UIManager.setLookAndFeel("com.sun.java.swing.plaf.motif.MotifLookAndFeel");
    }
    // Macintosh
    else if ( CurrentUI.equals("Macintosh") )
    {
      javax.swing.UIManager.setLookAndFeel("apple.laf.AquaLookAndFeel");
    }
    //
    javax.swing.JFrame.setDefaultLookAndFeelDecorated(true);
    javax.swing.JDialog.setDefaultLookAndFeelDecorated(true);
    //
    //
    //
    //
    //
    JFrame frame = new JFrame();
    frame.setTitle("FIRA indtpult");
    //
    OptionPanel = new OptionPane();
    //
    TabPanel = new JTabbedPane();
    TabPanel.addTab("Belltsok",new JScrollPane(OptionPanel));
    //
    frame.addWindowListener(new WindowAdapter()
    {
      public void windowClosing(WindowEvent e)
      {
        System.exit(0);
      }
    });
    //
    frame.getContentPane().setLayout(new BorderLayout());
    frame.getContentPane().add(TabPanel,BorderLayout.CENTER);
    frame.pack();
    //frame.setExtendedState(frame.MAXIMIZED_BOTH);
    frame.setLocationRelativeTo(null);
    frame.setVisible(true);
    OptionPanel.updateUI();
    Frame = frame;
  }

/**
* <code>main</code>.
*/
  public static void main(String[] args)
  {
    Runnable r = new Runnable()
    {
      public void run()
      {
        try
        {
          new FIRAStarter();
        }
        catch ( Throwable t )
        {
          UTIL_.RunExcOrErr(t);
        }
      }
    };
    SwingUtilities.invokeLater(r);
  }

/**
* A <code>FileChooser</code> visszaadsa.
*/
  protected FileChooser getFileChooser()
  {
    if ( FileChooser == null )
    {
      FileChooser = new FileChooser();
      FileChooser.setPreferredForcedSize(66,66);
      //
      String userdir = System.getProperty("user.dir");
      FileChooser.setCurrentDirectory(new File(userdir));
    }
    else
    {
      SwingUtilities.updateComponentTreeUI(FileChooser);
    }
    //
    return FileChooser;
  }

/**
* FIRA indtsa.
*/
  protected void actionStart()
  {
    try
    {
      while ( TabPanel.getTabCount() > 1 )
      {
        TabPanel.removeTabAt(TabPanel.getTabCount()-1);
      }
      //
      //
      // --- FIRA indts
      // statikus paramtertads
      if ( OptionPanel.EnableXmlText.isSelected() && !OptionPanel.TextArea_XmlText.isEmpty() )
      {
        hu.polysys.epa.client.fir.sign.Main.SetXmlText(OptionPanel.TextArea_XmlText.getText());
      }
      else
      {
        hu.polysys.epa.client.fir.sign.Main.SetXmlText(null);
      }
      // statikus belltsok
      hu.polysys.epa.client.Main_._EnableSplashWindow = OptionPanel.EnableSplashWindow.isSelected();
      hu.polysys.epa.client.Main_._EnableMenu = OptionPanel.EnableMenu.isSelected();
      hu.polysys.epa.client.Main_._EnableShowConfirmExitDialog = OptionPanel.EnableShowConfirmExitDialog.isSelected();
      int size = 32;
      try
      {
        size = Integer.parseInt(OptionPanel.Combo_IconSize.getSelectedID());
      }
      catch ( NumberFormatException e ) {}
      hu.polysys.epa.client.Main_._IconSize = size;
      hu.polysys.epa.client.Main_._EnableIconSizeMenu = OptionPanel.EnableIconSizeMenu.isSelected();
      if ( OptionPanel.EnableCurrentUI.isSelected() )
      {
        hu.polysys.epa.client.Main_._CurrentUI = OptionPanel.Combo_CurrentUI.getSelectedID();
      }
      else
      {
        hu.polysys.epa.client.Main_._CurrentUI = null;
      }
      hu.polysys.epa.client.fir.sign.Main._ShowUseThisKeyStoreInTheFuture = OptionPanel.ShowUseThisKeyStoreInTheFuture.isSelected();
      //
      // pldny ltrehozsa
      hu.polysys.epa.client.fir.sign.Main main = new hu.polysys.epa.client.fir.sign.Main(false,
                                                              hu.polysys.epa.client.fir.sign.Main.CreateSplashWindow());
      //
      // kilps figyel hozzads
      main.addAppExitListener(new PropertyChangeListener()
      {
        public void propertyChange(PropertyChangeEvent e)
        {
          while ( TabPanel.getTabCount() > 1 )
          {
            TabPanel.removeTabAt(TabPanel.getTabCount()-1);
          }
        }
      });
      // 
      // XML alrs elkszlt figyel hozzadsa
      main.addXmlSignatureReadyListener(new PropertyChangeListener()
      {
        public void propertyChange(PropertyChangeEvent e)
        {
          String xmlsigstr = (String)e.getNewValue();
          try
          {
            Dimension screensize = Toolkit.getDefaultToolkit().getScreenSize();
            int x = (int)(screensize.width  * 60/100);
            int y = (int)(screensize.height * 60/100);
            Dimension d = new Dimension(x,y);
            JPanel panel = new JPanel(new BorderLayout());
            panel.setSize(d);
            panel.setMinimumSize(d);
            panel.setPreferredSize(d);
            //
            XMLTabViewerPanel xmltabviewerpanel = new XMLTabViewerPanel(FIRA);
            panel.add(xmltabviewerpanel,BorderLayout.CENTER);
            xmltabviewerpanel.setContent(xmlsigstr);
            //
            JOptionPane.showMessageDialog(Frame,panel,"Alrs elkszlt",JOptionPane.INFORMATION_MESSAGE);
          }
          catch ( Throwable t )
          {
            String message = UTIL_.GetStackTrace(t);
            JOptionPane.showMessageDialog(Frame,message,"Hiba",JOptionPane.ERROR_MESSAGE);
          }
        }
      });
      //
      // hozzads
      TabPanel.addTab("FIRA",main);
      TabPanel.setSelectedIndex(TabPanel.getTabCount()-1);
      //
      // 
      // automatikus mretezs tiltsa
      main.enableSizingToLastKnown(false);
      // indts az input paramrek tadsva
      Hashtable args = createArgs();
      main.initialize(args);
      //
      // trols adattagban
      FIRA = main;
    }
    catch ( Throwable t )
    {
      String message = UTIL_.GetStackTrace(t);
      JOptionPane.showMessageDialog(Frame,message,"Hiba",JOptionPane.ERROR_MESSAGE);
    }
  }

/**
* FIRA input paramtereinek sszelltsa hash tblba.
*/
  private Hashtable createArgs()
  {
    Hashtable args = new Hashtable();
    if ( ! OptionPanel.TextField_help_url.isEmpty() )
      args.put("help-url",OptionPanel.TextField_help_url.getText());
    if ( ! OptionPanel.TextField_xml_url.isEmpty() )
      args.put("xml-url",OptionPanel.TextField_xml_url.getText());
    if ( ! OptionPanel.TextField_xsl_url.isEmpty() )
      args.put("xsl-url",OptionPanel.TextField_xsl_url.getText());
    if ( ! OptionPanel.TextField_upload_url.isEmpty() )
      args.put("upload-url",OptionPanel.TextField_upload_url.getText());
    if ( ! OptionPanel.TextField_upload_filename.isEmpty() )
      args.put("upload-filename",OptionPanel.TextField_upload_filename.getText());
    if ( ! OptionPanel.TextField_keystore_type.isEmpty() )
      args.put("keystore-type",OptionPanel.TextField_keystore_type.getText());
    if ( ! OptionPanel.TextField_keystore_value.isEmpty() )
      args.put("keystore-value",OptionPanel.TextField_keystore_value.getText());
    if ( ! OptionPanel.TextField_pass_signerkeychooser.isEmpty() )
      args.put("pass-signerkeychooser",OptionPanel.TextField_pass_signerkeychooser.getText());
    //
    if ( ! OptionPanel.P_EnableSplashWindow.isEmpty() )
      args.put("_EnableSplashWindow",OptionPanel.P_EnableSplashWindow.getText());
    if ( ! OptionPanel.P_EnableMenu.isEmpty() )
      args.put("_EnableMenu",OptionPanel.P_EnableMenu.getText());
    if ( ! OptionPanel.P_EnableShowConfirmExitDialog.isEmpty() )
      args.put("_EnableShowConfirmExitDialog",OptionPanel.P_EnableShowConfirmExitDialog.getText());
    if ( ! OptionPanel.P_IconSize.isEmpty() )
      args.put("_IconSize",OptionPanel.P_IconSize.getText());
    if ( ! OptionPanel.P_EnableIconSizeMenu.isEmpty() )
      args.put("_EnableIconSizeMenu",OptionPanel.P_EnableIconSizeMenu.getText());
    if ( ! OptionPanel.P_LAF.isEmpty() )
      args.put("_LAF",OptionPanel.P_LAF.getText());
    if ( ! OptionPanel.P_Theme.isEmpty() )
      args.put("_Theme",OptionPanel.P_Theme.getText());
    if ( ! OptionPanel.P_ShowUseThisKeyStoreInTheFuture.isEmpty() )
      args.put("_ShowUseThisKeyStoreInTheFuture",OptionPanel.P_ShowUseThisKeyStoreInTheFuture.getText());
    //
    return args;
  }

/**
* <code>JFileChooser</code> testreszabsa.
*/
  protected static void CustomizeFileChoosers()
  {
    UIManager.put("FileChooser.acceptAllFileFilterText","minden fjl (*.*)");
    //UIManager.put("FileChooser.ancestorInputMap = javax.swing.plaf.InputMapUIResource@26804e
    //UIManager.put("FileChooser.cancelButtonMnemonic = 67
    UIManager.put("FileChooser.cancelButtonText","mgsem");
    UIManager.put("FileChooser.cancelButtonToolTipText","ablak bezrsa");
    //UIManager.put("FileChooser.detailsViewButtonAccessibleName= Details
    UIManager.put("FileChooser.detailsViewButtonToolTipText","rszletek");
    //UIManager.put("FileChooser.detailsViewIcon = javax.swing.plaf.IconUIResource@237368
    UIManager.put("FileChooser.directoryDescriptionText","knyvtr");
    UIManager.put("FileChooser.fileDescriptionText","fjl");
    //UIManager.put("FileChooser.fileNameLabelMnemonic = 78
    UIManager.put("FileChooser.fileNameLabelText","Fjl nv:");
    //UIManager.put("FileChooser.filesOfTypeLabelMnemonic = 84
    UIManager.put("FileChooser.filesOfTypeLabelText","Fjl tpus:");
    //UIManager.put("FileChooser.helpButtonMnemonic = 72
    UIManager.put("FileChooser.helpButtonText","segtsg");
    UIManager.put("FileChooser.helpButtonToolTipText","segtsg");
    //UIManager.put("FileChooser.homeFolderAccessibleName = Home
    //UIManager.put("FileChooser.homeFolderIcon = javax.swing.plaf.IconUIResource@228a02
    //UIManager.put("FileChooser.homeFolderToolTipText = Home
    //UIManager.put("FileChooser.listViewButtonAccessibleName = List
    UIManager.put("FileChooser.listViewButtonToolTipText","lista");
    //UIManager.put("FileChooser.listViewIcon = javax.swing.plaf.IconUIResource@7bd6a1
    //UIManager.put("FileChooser.lookInLabelMnemonic = 73
    UIManager.put("FileChooser.lookInLabelText","Hely:");
    //UIManager.put("FileChooser.newFolderAccessibleName = New Folder
    //UIManager.put("FileChooser.newFolderErrorSeparator = :
    UIManager.put("FileChooser.newFolderErrorText","j knyvtr ltrehozsa nem sikerlt.");
    //UIManager.put("FileChooser.newFolderIcon = javax.swing.plaf.IconUIResource@66e815
    UIManager.put("FileChooser.newFolderToolTipText","j knyvtr ltrehozsa");
    //UIManager.put("FileChooser.openButtonMnemonic = 79
    UIManager.put("FileChooser.openButtonText","megnyits");
    UIManager.put("FileChooser.openButtonToolTipText","kijellt fjl megnyitsa");
    UIManager.put("FileChooser.openDialogTitleText","Megnyits");
    //UIManager.put("FileChooser.other.newFolder = NewFolder
    //UIManager.put("FileChooser.other.newFolder.subsequent = NewFolder.{0}
    //UIManager.put("FileChooser.saveButtonMnemonic = 83
    UIManager.put("FileChooser.saveButtonText","ments");
    UIManager.put("FileChooser.saveButtonToolTipText","kijellt fjl(ok) mentse");
    UIManager.put("FileChooser.saveDialogTitleText","Ments");
    //UIManager.put("FileChooser.updateButtonMnemonic = 85
    UIManager.put("FileChooser.updateButtonText","frissts");
    UIManager.put("FileChooser.updateButtonToolTipText","Knyvtr lista frisstse");
    //UIManager.put("FileChooser.upFolderAccessibleName = Up
    //UIManager.put("FileChooser.upFolderIcon = javax.swing.plaf.IconUIResource@5d46f7
    UIManager.put("FileChooser.upFolderToolTipText","egy szinttel feljebb");
    //UIManager.put("FileChooser.win32.newFolder = New Folder
    //UIManager.put("FileChooser.win32.newFolder.subsequent = New Folder ({0})
    UIManager.put("FileChooser.directoryOpenButtonText","megnyits");
    UIManager.put("FileChooser.saveInLabelText","Ments helye:");
    //
    // a tblzat fejrsze
    UIManager.put("FileChooser.fileNameHeaderText","nv");
    UIManager.put("FileChooser.fileSizeHeaderText","mret");
    UIManager.put("FileChooser.fileTypeHeaderText","tpus");
    UIManager.put("FileChooser.fileDateHeaderText","dtum");
    UIManager.put("FileChooser.fileAttrHeaderText","attr.");
    //
    UIManager.put("FileChooser.cancelButtonText","mgsem");
    UIManager.put("FileChooser.cancelButtonToolTipText","ablak bezrsa");
  }

  // -------------------------- class OptionPane -----------------------------------------------------------------------
  class OptionPane extends JPanel
  {
    InputTextField TextField_help_url;
    InputTextField TextField_xml_url;
    InputTextField TextField_xsl_url;
    InputTextField TextField_upload_url;
    InputTextField TextField_upload_filename;
    InputTextField TextField_keystore_type;
    InputTextField TextField_keystore_value;
    InputTextField TextField_pass_signerkeychooser;
    
    InputLogicalField EnableXmlText;
    InputTextArea TextArea_XmlText;
    InputLogicalField EnableSplashWindow;
    InputLogicalField EnableShowConfirmExitDialog;
    InputLogicalField EnableMenu;
    InputLogicalField EnableIconSizeMenu;
    ComboBoxWithID Combo_IconSize;
    InputLogicalField EnableCurrentUI;
    ComboBoxWithID Combo_CurrentUI;
    InputLogicalField ShowUseThisKeyStoreInTheFuture;
    
    InputTextField P_EnableSplashWindow;
    InputTextField P_EnableMenu;
    InputTextField P_EnableShowConfirmExitDialog;
    InputTextField P_IconSize;
    InputTextField P_EnableIconSizeMenu;
    InputTextField P_LAF;
    InputTextField P_Theme;
    InputTextField P_ShowUseThisKeyStoreInTheFuture;
    
    ComboBoxWithID Combo_LAF;
    ComboBoxWithID Combo_Theme;
    
    
    OptionPane()
    {
      super(new BorderLayout());
      init();
    }
    
    void init()
    {
      TitledBorder titledborder;
      JPanel line;
      JPanel grid;
      StringBuffer sb = new StringBuffer();
      //
      //
      JPanel panel = new JPanel(new GridLayout(2,1));
      add(panel,BorderLayout.CENTER);
      //
      // --- nyomgombok (alul)
      ButtonPanel buttonpanel = new ButtonPanel();
      final JButton htmlbutton = new JButton("indt HTML");
      htmlbutton.setIcon(ButtonFactory.LoadIcon(ButtonFactory.OPTIONS,getClass().getClassLoader()));
      buttonpanel.add(htmlbutton);
      htmlbutton.addActionListener(new ActionListener()
      {
        public void actionPerformed(ActionEvent e)
        {
          Runnable r = new Runnable()
          {
            public void run()
            {
              htmlbutton.setEnabled(false);
              new FileCreateDialog("HTML");
              htmlbutton.setEnabled(true);
            }
          };
          polysys.ext.client.SwingHelper.RunOnEventDispatchThread(r);
        }
      });
      final JButton jnlpbutton = new JButton("indt JNLP");
      jnlpbutton.setIcon(ButtonFactory.LoadIcon(ButtonFactory.OPTIONS,getClass().getClassLoader()));
      buttonpanel.add(jnlpbutton);
      jnlpbutton.addActionListener(new ActionListener()
      {
        public void actionPerformed(ActionEvent e)
        {
          Runnable r = new Runnable()
          {
            public void run()
            {
              htmlbutton.setEnabled(false);
              new FileCreateDialog("JNLP");
              htmlbutton.setEnabled(true);
            }
          };
          polysys.ext.client.SwingHelper.RunOnEventDispatchThread(r);
        }
      });
      final JButton startbutton = new JButton("FIRA indtsa");
      startbutton.setIcon(ButtonFactory.LoadIcon(ButtonFactory.OK,getClass().getClassLoader()));
      buttonpanel.add(startbutton);
      startbutton.addActionListener(new ActionListener()
      {
        public void actionPerformed(ActionEvent e)
        {
          Runnable r = new Runnable()
          {
            public void run()
            {
              startbutton.setEnabled(false);
              actionStart();
              startbutton.setEnabled(true);
            }
          };
          polysys.ext.client.SwingHelper.RunOnEventDispatchThread(r);
        }
      });
      add(buttonpanel,BorderLayout.SOUTH);
      //
      //
      // --- statikus paramterek (fell)
      JPanel upperpanel = new JPanel(new GridLayout(1,2));
      titledborder = GUI_.GetTitledBorder();
      titledborder.setTitle("Hvs eltt statikusan belltott paramterek:");
      upperpanel.setBorder(titledborder);
      RowPanel rowpanel2 = createRowPanel();
      upperpanel.add(rowpanel2);
      JPanel textpanel = new JPanel(new BorderLayout());
      upperpanel.add(textpanel);
      panel.add(upperpanel);
      //
      // CurrentUI
      EnableCurrentUI = new InputLogicalField();
      EnableCurrentUI.setSelected(true);
      rowpanel2.addLeft(EnableCurrentUI);
      rowpanel2.addRight(new JLabel("UI-t a hv Java alkalmazs elzetesen belltotta"));
      EnableCurrentUI.addActionListener(new ActionListener()
      {
        public void actionPerformed(ActionEvent e)
        {
          Combo_CurrentUI.setEnabled(EnableCurrentUI.isSelected());
        }
      });
      Combo_CurrentUI = new ComboBoxWithID();
      Combo_CurrentUI.addItem("Metal","Metal UI");
      Combo_CurrentUI.addItem("Ocean","Ocean UI");
      Combo_CurrentUI.addItem("Windows","Windows UI");
      Combo_CurrentUI.addItem("Macintosh","Macintosh UI");
      Combo_CurrentUI.addItem("Kunststoff","Kunststoff UI");
      line = new LinePanel();
      line.add(new JLabel("UI:"));
      line.add(Combo_CurrentUI);
      line.add(new JLabel("(_CurrentUI)"));
      rowpanel2.addLeft(new JLabel());
      rowpanel2.addRight(line);
      EnableCurrentUI.setSelected(false);
      Combo_CurrentUI.setEnabled(false);
      Combo_CurrentUI.setSelectedID(CurrentUI);
      //
      // _EnableSplashWindow
      EnableSplashWindow = new InputLogicalField();
      EnableSplashWindow.setSelected(true);
      rowpanel2.addLeft(EnableSplashWindow);
      rowpanel2.addRight(new JLabel("splash megjelents engedlyezse (_EnableSplashWindow)"));
      //
      // _EnableShowConfirmExitDialog
      EnableShowConfirmExitDialog = new InputLogicalField();
      EnableShowConfirmExitDialog.setSelected(true);
      rowpanel2.addLeft(EnableShowConfirmExitDialog);
      rowpanel2.addRight(new JLabel("kilps megersts engedlyezse (_EnableShowConfirmExitDialog)"));
      //
      // _EnableMenu
      EnableMenu = new InputLogicalField();
      EnableMenu.setSelected(true);
      rowpanel2.addLeft(EnableMenu);
      rowpanel2.addRight(new JLabel("men megjelents engedlyezse (_EnableMenu)"));
      EnableMenu.addActionListener(new ActionListener()
      {
        public void actionPerformed(ActionEvent e)
        {
          EnableIconSizeMenu.setEnabled(EnableMenu.isSelected());
          if ( ! EnableMenu.isSelected() && EnableIconSizeMenu.isSelected() )
            EnableIconSizeMenu.setSelected(false);
        }
      });
      //
      // _EnableIconSizeMenu
      EnableIconSizeMenu = new InputLogicalField();
      EnableIconSizeMenu.setSelected(true);
      rowpanel2.addLeft(EnableIconSizeMenu);
      rowpanel2.addRight(new JLabel("ikon mret almen megjelents engedlyezse (_EnableIconSizeMenu)"));
      //
      // IconSize
      Combo_IconSize = new ComboBoxWithID();
      Combo_IconSize.addItem("16","16 pixel");
      Combo_IconSize.addItem("24","24 pixel");
      Combo_IconSize.addItem("32","32 pixel");
      Combo_IconSize.addItem("48","48 pixel");
      Combo_IconSize.setSelectedID("32");
      line = new LinePanel();
      line.add(Combo_IconSize);
      line.add(new JLabel("ikon mret pixelben (_IconSize)"));
      rowpanel2.addLeft(new JLabel());
      rowpanel2.addRight(line);
      //
      // _ShowUseThisKeyStoreInTheFuture
      ShowUseThisKeyStoreInTheFuture = new InputLogicalField();
      ShowUseThisKeyStoreInTheFuture.setSelected(true);
      rowpanel2.addLeft(ShowUseThisKeyStoreInTheFuture);
      rowpanel2.addRight(new JLabel("azonos kulcstrol jellngyzet megjelents engedlyezse (_ShowUseThisKeyStoreInTheFuture)"));
      //
      //
      // SetXmlText
      EnableXmlText = new InputLogicalField();
      rowpanel2.addLeft(EnableXmlText);
      rowpanel2.addRight(new JLabel("XML string tadsa a statikus SetXmlText() metdussal"));
      sb.setLength(0);
      sb.append("|Az albbi szvegdobozba rja be vagy| illessze be (Ctrl+V) az adatszolgltatst, mint XML stringet!|");
      textpanel.add(new MultiLinePanel(sb.toString()),BorderLayout.NORTH);
      TextArea_XmlText = new InputTextArea();
      TextArea_XmlText.enableFocusChangeColoring(false);
      TextArea_XmlText.setEnabled(false);
      textpanel.add(TextArea_XmlText,BorderLayout.CENTER);
      EnableXmlText.addActionListener(new ActionListener()
      {
        public void actionPerformed(ActionEvent e)
        {
          TextArea_XmlText.setEnabled(EnableXmlText.isSelected());
        }
      });
      rowpanel2.addLeft(createSpacer());
      rowpanel2.addRight(createSpacer());
      //
      //
      // --- input paramterek rsz (alul)
      RowPanel rowpanel11 = createRowPanel();
      rowpanel11.addLeft(new JLabel());
      rowpanel11.addRight(new JLabel("Mkdst befolysol input paramterek:"));
      RowPanel rowpanel12 = createRowPanel();
      rowpanel12.addLeft(new JLabel());
      rowpanel12.addRight(new JLabel("Ltvnyt befolysol input paramterek:"));
      JPanel lowerpanel = new JPanel(new GridLayout(1,2));
      lowerpanel.add(rowpanel11);
      lowerpanel.add(rowpanel12);
      panel.add(lowerpanel);
      titledborder = GUI_.GetTitledBorder();
      titledborder.setTitle("Hvsnl tadott input paramterek:");
      lowerpanel.setBorder(titledborder);
      //
      // help-url
      rowpanel11.addLeft(new JLabel("help-url"));
      TextField_help_url = new InputTextField("",1000,TEXT_FIELD_WIDTH);
      TextField_help_url.enableFocusChangeColoring(false);
      rowpanel11.addRight(TextField_help_url);
      //
      // xml-url
      rowpanel11.addLeft(new JLabel("xml-url"));
      TextField_xml_url = new InputTextField("",1000,TEXT_FIELD_WIDTH);
      TextField_xml_url.enableFocusChangeColoring(false);
      rowpanel11.addRight(TextField_xml_url);
      //
      // xsl-url
      rowpanel11.addLeft(new JLabel("xsl-url"));
      TextField_xsl_url = new InputTextField("",1000,TEXT_FIELD_WIDTH);
      TextField_xsl_url.enableFocusChangeColoring(false);
      rowpanel11.addRight(TextField_xsl_url);
      //
      // upload-url
      rowpanel11.addLeft(new JLabel("upload-url"));
      TextField_upload_url = new InputTextField("",1000,TEXT_FIELD_WIDTH);
      TextField_upload_url.enableFocusChangeColoring(false);
      //TextField_upload_url.setText("http://localhost:8081/epa/signeddoc.post.action");
      rowpanel11.addRight(TextField_upload_url);
      //
      // upload-filename
      rowpanel11.addLeft(new JLabel("upload-filename"));
      TextField_upload_filename = new InputTextField("",1000,TEXT_FIELD_WIDTH);
      TextField_upload_filename.enableFocusChangeColoring(false);
      rowpanel11.addRight(TextField_upload_filename);
      //
      // keystore_type
      rowpanel11.addLeft(new JLabel("keystore_type"));
      TextField_keystore_type = new InputTextField("",1000,TEXT_FIELD_WIDTH);
      TextField_keystore_type.enableFocusChangeColoring(false);
      rowpanel11.addRight(TextField_keystore_type);
      //
      // keystore_value
      rowpanel11.addLeft(new JLabel("keystore_value"));
      TextField_keystore_value = new InputTextField("",1000,TEXT_FIELD_WIDTH);
      TextField_keystore_value.enableFocusChangeColoring(false);
      rowpanel11.addRight(TextField_keystore_value);
      //
      // pass_signerkeychooser
      rowpanel11.addLeft(new JLabel("pass_signerkeychooser"));
      TextField_pass_signerkeychooser = new InputTextField("",1000,TEXT_FIELD_WIDTH);
      TextField_pass_signerkeychooser.enableFocusChangeColoring(false);
      rowpanel11.addRight(TextField_pass_signerkeychooser);
      //
      //
      // P_EnableSplashWindow
      rowpanel12.addLeft(new JLabel("_EnableSplashWindow"));
      P_EnableSplashWindow = new InputTextField("",1000,TEXT_FIELD_WIDTH);
      P_EnableSplashWindow.enableFocusChangeColoring(false);
      rowpanel12.addRight(P_EnableSplashWindow);
      //
      // P_EnableShowConfirmExitDialog
      rowpanel12.addLeft(new JLabel("_EnableShowConfirmExitDialog"));
      P_EnableShowConfirmExitDialog = new InputTextField("",1000,TEXT_FIELD_WIDTH);
      P_EnableShowConfirmExitDialog.enableFocusChangeColoring(false);
      rowpanel12.addRight(P_EnableShowConfirmExitDialog);
      //
      // P_EnableMenu
      rowpanel12.addLeft(new JLabel("_EnableMenu"));
      P_EnableMenu = new InputTextField("",1000,TEXT_FIELD_WIDTH);
      P_EnableMenu.enableFocusChangeColoring(false);
      rowpanel12.addRight(P_EnableMenu);
      //
      // P_EnableIconSizeMenu
      rowpanel12.addLeft(new JLabel("_EnableIconSizeMenu"));
      P_EnableIconSizeMenu = new InputTextField("",1000,TEXT_FIELD_WIDTH);
      P_EnableIconSizeMenu.enableFocusChangeColoring(false);
      rowpanel12.addRight(P_EnableIconSizeMenu);
      //
      // P_IconSize
      rowpanel12.addLeft(new JLabel("_IconSize"));
      P_IconSize = new InputTextField("",1000,TEXT_FIELD_WIDTH);
      P_IconSize.enableFocusChangeColoring(false);
      rowpanel12.addRight(P_IconSize);
      //
      // P_ShowUseThisKeyStoreInTheFuture
      rowpanel12.addLeft(new JLabel("_ShowUseThisKeyStoreInTheFuture"));
      P_ShowUseThisKeyStoreInTheFuture = new InputTextField("",1000,TEXT_FIELD_WIDTH);
      P_ShowUseThisKeyStoreInTheFuture.enableFocusChangeColoring(false);
      rowpanel12.addRight(P_ShowUseThisKeyStoreInTheFuture);
      //
      // P_LAF
      rowpanel12.addLeft(new JLabel("_LAF"));
      P_LAF = new InputTextField("",1000,TEXT_FIELD_WIDTH/2);
      P_LAF.enableFocusChangeColoring(false);
      grid = new JPanel(new GridLayout(1,2));
      grid.add(P_LAF);
        final ComboBoxWithID combolaf = new ComboBoxWithID();
        combolaf.addItem("","");
        combolaf.addItem("Windows","Windows");
        combolaf.addItem("Motif","Motif");
        combolaf.addItem("Metal","Metal");
        combolaf.addItem("Kunststoff","Kunststoff");
        combolaf.addItem("Ocean","Ocean");
        combolaf.addItem("Macintosh","Macintosh");
        combolaf.addItemListener(new ItemListener()
        {
          public void itemStateChanged(ItemEvent e)
          {
            if ( e.getStateChange() != ItemEvent.SELECTED )
              return;
            P_LAF.setText(combolaf.getSelectedID());
          }
        });
        grid.add(combolaf);
        Combo_LAF = combolaf;
      rowpanel12.addRight(grid);
      //
      // P_Theme
      rowpanel12.addLeft(new JLabel("_Theme"));
      P_Theme = new InputTextField("",1000,TEXT_FIELD_WIDTH/2);
      P_Theme.enableFocusChangeColoring(false);
      grid = new JPanel(new GridLayout(1,2));
      grid.add(P_Theme);
        final ComboBoxWithID combotheme = new ComboBoxWithID();
        combotheme.addItem("","");
        // alap
        combotheme.addItem("JAVA default","szoksos");
        combotheme.addItem("Presentation","bemutat");
        combotheme.addItem("BigContrast","nincs kznl a szemvegem");
        combotheme.addItem("Projector800x600","projektor (800x600)");
        // hangulatok
        combotheme.addItem("Capuccino","capuccino");
        combotheme.addItem("BlackCoffee","ers kv cukor nlkl");
        combotheme.addItem("Jaffa","jaffa");
        combotheme.addItem("BlueSky","brnyfelh");
        combotheme.addItem("Punch","puncsfagylalt");
        combotheme.addItem("Spectrum","spektrum");
        combotheme.addItem("SnowLimit","hhatr");
        combotheme.addItem("Carib","karib tenger");
        combotheme.addItem("Uranium","urnium");
        combotheme.addItem("RainForest","eserd");
        combotheme.addItem("Pepita","pepita");
        combotheme.addItem("Pool","medence");
        combotheme.addItem("EU","EU");
        combotheme.addItem("YellowtailDamselfish","srga fark korallsgr");
        // kunststoff
        combotheme.addItem("Kunststoff desktop","asztal");
        combotheme.addItem("Kunststoff notebook","notebook");
        combotheme.addItem("Kunststoff presentation","prezentci");
        // sznek
        combotheme.addItem("Contrast","fekete-fehr");
        combotheme.addItem("Auburn","-arany");
        combotheme.addItem("Gold","arany");
        combotheme.addItem("Steel","acl");
        combotheme.addItem("Lilac","orgona");
        combotheme.addItem("PastelGreen","pasztellzld");
        combotheme.addItem("Bourdon","bord (nagy betmret)");
        combotheme.addItem("GrayAndPink","szrke-rzsaszn");
        combotheme.addItem("DarkBlue","sttkk");
        combotheme.addItem("BlackAndRed","piros-fekete");
        //
        combotheme.addItemListener(new ItemListener()
        {
          public void itemStateChanged(ItemEvent e)
          {
            if ( e.getStateChange() != ItemEvent.SELECTED )
              return;
            P_Theme.setText(combotheme.getSelectedID());
          }
        });
        grid.add(combotheme);
        Combo_Theme = combotheme;
      rowpanel12.addRight(grid);
      //
      //
      // inicializls
      File file = null;
      String userdir = System.getProperty("user.dir");
      //
      sb.setLength(0);
      sb.append(userdir);
      sb.append(File.separator);
      sb.append("test");
      sb.append(File.separator);
      sb.append("order.xml");
      file = new File(sb.toString());
      try
      {
        TextField_xml_url.setText(file.toURI().toURL().toString());    // "file:./test/order.xml"
      }
      catch ( MalformedURLException e ) {}
      //
      sb.setLength(0);
      sb.append(userdir);
      sb.append(File.separator);
      sb.append("test");
      sb.append(File.separator);
      sb.append("order.xsl");
      file = new File(sb.toString());
      try
      {
        TextField_xsl_url.setText(file.toURI().toURL().toString());                // "file:./test/order.xsl"
      }
      catch ( MalformedURLException e ) {}
      //
      //
      Dimension screensize = Toolkit.getDefaultToolkit().getScreenSize();
      int x,y;
      x = (int)(screensize.width * 90/100);
      y = (int)(screensize.height * 80/100);
      Dimension sd = new Dimension(x,y);
      setPreferredSize(sd);
      setSize(sd);
      //
      revalidate();
    }
    
    private RowPanel createRowPanel()
    {
      RowPanel rowpanel = GUI_.CreateRowPanelWithNoBorderMiddleGap();
      return rowpanel;
    }

    private JPanel createSpacer()
    {
      JPanel panel = new JPanel();
      panel.setBorder(GUI_.GetEmptyBorder(0,20,0,20));
      return panel;
    }
    
    public void updateUI()
    {
      super.updateUI();
      //
      if ( P_LAF != null )
      {
        revalidate();
        //
        InputTextField itf = new InputTextField("",1000,TEXT_FIELD_WIDTH/2);
        //Dimension d1 = itf.getPreferredSize();
        Dimension d1 = P_LAF.getPreferredSize();
        P_LAF.setPreferredSize(d1);
        P_LAF.setSize(d1);
        P_Theme.setPreferredSize(d1);
        P_Theme.setSize(d1);
        //
        Dimension d2 = Combo_LAF.getPreferredSize();
        Dimension d3 = new Dimension(d1.width,d2.height);
        Combo_LAF.setPreferredSize(d3);
        Combo_LAF.setSize(d3);
        Combo_Theme.setPreferredSize(d3);
        Combo_Theme.setSize(d3);
        //
        revalidate();
      }
    }
  }
  // -------------------------- eof OptionPane -------------------------------------------------------------------------

  // ------------------------- class CreateFileDialog ------------------------------------------------------------------
  class FileCreateDialog
  {
  
    FileCreateDialog(final String type)
    {
      final StringBuffer sb = new StringBuffer();
      //
      Hashtable args = createArgs();
      //
      // HTML
      if ( type.equals("HTML") )
      {
        sb.append("<html>\r\n");
        sb.append("<body>\r\n");
        sb.append("\r\n");
        sb.append("<applet\r\n");
        sb.append("    code=hu.polysys.epa.client.fir.sign.Main.class\r\n");
        sb.append("    name=FIRA Signer Applet\r\n");
        sb.append("    archive=\"fira2.jar, serializer.jar, xalan.jar, xercesImpl.jar, fira.jar\"\r\n");
        sb.append("    width=100%\r\n");
        sb.append("    height=100% >\r\n");
        //
        if ( args.size() > 0 )
          sb.append("\r\n");
        Enumeration e = args.keys();
        while ( e.hasMoreElements() )
        {
          String key = (String)e.nextElement();
          String value = (String)args.get(key);
          //
          if ( ! UTIL_.Empty(value) )
          {
            sb.append("    <param name=\"");
            sb.append(key);
            sb.append("\"");
            sb.append(" ");
            sb.append("value=\"");
            sb.append(value);
            sb.append("\"");
            sb.append(">\r\n");
          }
        }
        //
        sb.append("</applet>\r\n");
        sb.append("\r\n");
        sb.append("</body>\r\n");
        sb.append("</html>\r\n");
      }
      // JNLP
      else
      {
        sb.append("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\r\n");
        sb.append("<jnlp\r\n");
        sb.append("  spec=\"1.0+\"\r\n");
        sb.append("  codebase=\"http://localhost:8080/fira\">\r\n");
        sb.append("  <information>\r\n");
        sb.append("    <title>FIRA alr alkalmazs</title>\r\n");
        sb.append("    <vendor>Polysys Kft</vendor>\r\n");
        sb.append("    <icon href=\"fira_256.gif\"/>\r\n");
        sb.append("    <description>FIRA alr alkalmazs</description>\r\n");
        sb.append("    <description kind=\"short\">FIRA alr alkalmazs</description>\r\n");
        sb.append("  </information>\r\n");
        sb.append("    <security> <all-permissions/> </security>\r\n");
        sb.append("\r\n");
        sb.append("  <resources>\r\n");
        sb.append("    <j2se href=\"http://java.sun.com/products/autodl/j2se\" version=\"1.7+\" initial-heap-size=\"128m\" max-heap-size=\"512m\"/>\r\n");
        sb.append("    <j2se href=\"http://java.sun.com/products/autodl/j2se\" version=\"1.6+\" initial-heap-size=\"128m\" max-heap-size=\"512m\"/>\r\n");
        sb.append("    <j2se href=\"http://java.sun.com/products/autodl/j2se\" version=\"1.5+\" initial-heap-size=\"128m\" max-heap-size=\"512m\"/>\r\n");
        sb.append("    <property name=\"sun.awt.noerasebackground\" value=\"true\"/>\r\n");
        sb.append("\r\n");
        sb.append("    <jar href=\"fira.jar\"/>\r\n");
        sb.append("    <jar href=\"fira2.jar\"/>\r\n");
        sb.append("    <jar href=\"serializer.jar\"/>\r\n");
        sb.append("    <jar href=\"xalan.jar\"/>\r\n");
        sb.append("    <jar href=\"xercesImpl.jar\"/>\r\n");
        sb.append("  </resources>\r\n");
        sb.append("\r\n");
        sb.append("  <application-desc\r\n");
        sb.append("    main-class=\"hu.polysys.epa.client.fir.sign.Main\"\r\n");
        sb.append("    width=\"600\"\r\n");
        sb.append("    height=\"400\">\r\n");
        //
        if ( args.size() > 0 )
          sb.append("\r\n");
        Enumeration e = args.keys();
        while ( e.hasMoreElements() )
        {
          String key = (String)e.nextElement();
          String value = (String)args.get(key);
          //
          if ( ! UTIL_.Empty(value) )
          {
            sb.append("    <argument>");
            sb.append(key);
            sb.append("=");
            sb.append(value);
            sb.append("</argument>\r\n");
          }
        }
        sb.append(" </application-desc>\r\n");
        sb.append("\r\n");
        sb.append("</jnlp>\r\n");
      }
      //
      //
      final JDialog dialog = new JDialog(Frame,false);
      dialog.setTitle(type+" indt fjl");
      JPanel panel = new JPanel(new BorderLayout());
      dialog.getContentPane().setLayout(new BorderLayout());
      dialog.getContentPane().add(panel,BorderLayout.CENTER);
      //
      InputTextArea ita = null;
      ita = new InputTextArea(66,66);
      if ( FIRA != null && FIRA.getAssistant() != null )
        ita.activateFullScreenEditing(FIRA.getAssistant(),dialog.getTitle());
      ita.enableFocusChangeColoring(false);
      ita.setText(sb.toString());
      panel.add(ita,BorderLayout.CENTER);
      final InputTextArea inputtextarea = ita;
      //
      ButtonPanel buttonpanel = new ButtonPanel();
      final JButton savebutton = new JButton("ment");
      savebutton.setIcon(ButtonFactory.LoadIcon(ButtonFactory.SAVE,getClass().getClassLoader()));
      buttonpanel.add(savebutton);
      savebutton.addActionListener(new ActionListener()
      {
        public void actionPerformed(ActionEvent e)
        {
          FileChooser filechooser = getFileChooser();
          int val = filechooser.showSaveDialog(dialog);
          if ( val == JFileChooser.APPROVE_OPTION && filechooser.getSelectedFile() != null )
          {
            try
            {
              String s = inputtextarea.getText();
              byte[] data = null;
              if ( "JNLP".equals(type) )
                data = s.getBytes("UTF-8");
              else
                data = s.getBytes();
              //
              FileOutputStream fos = new FileOutputStream(filechooser.getSelectedFile());
              fos.write(data);
              fos.flush();
              fos.close();
            }
            catch ( Throwable t )
            {
              String message = UTIL_.GetStackTrace(t);
              JOptionPane.showMessageDialog(dialog,message,"Hiba",JOptionPane.ERROR_MESSAGE);
            }
          }
        }
      });
      final JButton closebutton = new JButton("bezr");
      closebutton.setIcon(ButtonFactory.LoadIcon(ButtonFactory.CANCEL,getClass().getClassLoader()));
      buttonpanel.add(closebutton);
      closebutton.addActionListener(new ActionListener()
      {
        public void actionPerformed(ActionEvent e)
        {
          dialog.setVisible(false);
        }
      });
      panel.add(buttonpanel,BorderLayout.SOUTH);
      //
      dialog.pack();
      dialog.setResizable(true);
      dialog.setLocationRelativeTo(Frame);
      dialog.setVisible(true);
    }
  }
  
}
